-module(ebb_pipe).
-include("../include/ebb_prim.hrl").
-include("../include/ebb_pipe.hrl").
-export([pipe/2, pipe/1, bind/2, feed/2, sequence/2, sequence/1]).

pipe(Op1, Op2) ->
    #pipe{ops=[Op1, Op2]}.

pipe(Ops) ->
    #pipe{ops=Ops}.

bind(Task, FuncT) ->
    feed(Task, #dynamic{code=FuncT}).

feed(Task, Op) ->
    #feed{task=Task, op=Op}.

sequence(Task1, Task2) ->
    #sequence{tasks=[Task1, Task2]}.

sequence(Tasks) ->
    #sequence{tasks=Tasks}.
